unit dmuClient;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBClient, BS_ClientDataSet
  ,dmuRemote
  ;

type
  TdmClient = class(TDataModule)
    cdsDept: TBS_ClientDataSet;
    dsDept: TDataSource;
    procedure DataModuleDestroy(Sender: TObject);
    procedure cdsDeptAfterDelete(DataSet: TDataSet);
    procedure cdsDeptAfterPost(DataSet: TDataSet);
    procedure cdsDeptBeforeClose(DataSet: TDataSet);
  private
    procedure cdsDeptApplyUpdates;
  public
    function Login():boolean;
    procedure Logout();
  end;

var
  dmClient: TdmClient;

implementation

{$R *.DFM}

{ TdmClient }

function TdmClient.Login: boolean;
begin
  dmRemote.dbConnection.Connected:=true;
  result:=dmRemote.dbConnection.Connected;
end;

procedure TdmClient.Logout;
begin
  dmRemote.dbConnection.Connected:=false;
end;

procedure TdmClient.DataModuleDestroy(Sender: TObject);
var
  i:integer;
begin
  for i:=0 to Self.ComponentCount-1 do
    if (self.Components[i] is TBS_ClientDataSet) and
       (TBS_ClientDataSet(self.Components[i]).Active) then
      begin
        TBS_ClientDataSet(self.Components[i]).Close;
      end;
end;

procedure TdmClient.cdsDeptApplyUpdates;
begin
  if cdsDept.ChangeCount > 0 then
    cdsDept.ApplyUpdates(-1);
end;

procedure TdmClient.cdsDeptAfterDelete(DataSet: TDataSet);
begin
  cdsDeptApplyUpdates();
end;

procedure TdmClient.cdsDeptAfterPost(DataSet: TDataSet);
begin
  cdsDeptApplyUpdates();
end;

procedure TdmClient.cdsDeptBeforeClose(DataSet: TDataSet);
begin
  if (cdsDept.State in [dsInsert,dsEdit]) then
    cdsDept.Post;
end;

end.
